#ifndef ChipSize_H
#define ChipSize_H

#include <iostream>

#include <Exception/Exception.h>

#include <rdbxx/simpleRDBTable.h>

class ChipSize {

    friend std::ostream& operator << ( std::ostream& os, ChipSize& a ) {
    a.print( os );
    return os;
  }

    friend std::ostream& operator << ( std::ostream& os, ChipSize* a ) {
    a->print( os );
    return os;
  }

public:

  enum Pos { XXX, YYY };

  virtual ~ChipSize( ) { }

  ChipSize( ) { }

  ChipSize( const char* header[], RDBColumn** rdb_column ) ;

  ChipSize( const ChipSize& c ) { *this = c; }

  ChipSize& operator = ( const ChipSize& rhs );

  void init_ChipSize( const char* header[], RDBColumn** rdb_column ) ;

  void print( std::ostream& os ) const;

protected:

  std::string name;

  int id;

  int chip_size_pix[ 2 ];

  double pixel_size_micron[ 2 ];

  double chip_size_mm[ 2 ];

};

#endif
