#include <cstdlib>
#include <iostream>
#include <rdbxx/RDB.h>

using namespace std;

// Using group columns, find the min and max values as well as the
// number of elements in a group.
int main( int argc, char* argv[] ) {

  try {
    // Set up input and output files...
    RDB irdb, ordb;
    bool first = true;
    
    while ( cin >> irdb ) {
      if ( first ) {
	for ( int idx = 0; idx < irdb.nComments( ); idx++ )
	  ordb.setComment( irdb.getComment( idx ) );
	for ( int idx = 0; idx < irdb.nColumns( ); idx++ )
	  ordb.setColumn( irdb.getColumn( idx ) );

	first = false;

      }

      std::cout << ordb;

    }

  } catch ( RDBErr& re ) {
    std::cerr << "RDBErr:" << std::endl << re << std::endl;
    return EXIT_FAILURE;
    
  } catch ( Exception& E ) {
    std::cerr << "Exception:" << std::endl << E << std::endl;
    return EXIT_FAILURE;

  } catch ( std::exception& e ) {
    std::cerr << "exception:" << std::endl << e.what( ) << std::endl;
    return EXIT_FAILURE;
    
  } catch ( ... ) {
    std::cerr << "Caught something unexpected..." << std::endl;
    return EXIT_FAILURE;

  }

  return EXIT_SUCCESS;
}
