#include <cstdlib>

#include <rdbxx/simpleRDBTable.h>

#include "ChipSize.h"

int testit( ) {

  const char* rdb_size_header[] = { "chip", "id",
				    "xsize_pix",  "ysize_pix",
				    "xpixelsize", "ypixelsize",
				    "xsize_mm",   "ysize_mm", NULL };
  
  simpleRDBTable< ChipSize > my_rdb( "hrc-size.rdb", std::ios::in,
				     rdb_size_header );
  
  std::cout << my_rdb << std::endl;
  ChipSize* chip_size = NULL;
  while( NULL != (chip_size = my_rdb.readRow( )) ) {
    std::cout << *chip_size << std::endl;
    delete chip_size;
  }

  return 0;
}

int main( int argc, char** argv ) {

  try {
    testit( );

  } catch ( Exception& e ) {
    std::cerr << argv[0] << ":  " << e << std::endl;

  } catch ( std::exception& e ) {
    std::cerr << argv[0] << ":  " << e.what( ) << std::endl;

  } catch ( ... ) {
    std::cerr << "Caught something... not quite sure what though." << std::endl;

  }

  return EXIT_SUCCESS;

}
