#define CATCH_CONFIG_MAIN
#include <catch2/catch.hpp>

#include <rdbxx/RDBColumnTmplt.h>

using namespace std;

TEST_CASE( "RDBColumnTmplt Test Suite" ) {

  RDBDoubleColumn dblcol( "DOUBLE", "N" );
  RDBLongColumn lngcol( "LONG", "N" );
  RDBStringColumn strcol( "STRING", "S" );

  RDBColumn* cols[3];
  cols[0] = &dblcol;
  cols[1] = &lngcol;
  cols[2] = &strcol;

  cols[0]->setThrow( false );
  cols[1]->setThrow( false );
  cols[2]->setThrow( false );

  double d = 3.141;
  long l = 9876;
  string s = "141.3";

  cols[0]->setData( d );
  REQUIRE( dblcol.getDataDouble( ) == d );
  REQUIRE( dblcol.getDataLong( ) == 3 );
  string output = dblcol.getDataString( );
  string expected( "3.141" );
  REQUIRE( output == expected );

  cols[0]->setData( l );
  REQUIRE( dblcol.getDataDouble( ) == 9876.0 );
  REQUIRE( dblcol.getDataLong( ) == l );
  REQUIRE( dblcol.getDataString( ) == "9876" );
  cols[0]->setData( s );
  REQUIRE( dblcol.getDataDouble( ) == 141.3 );
  REQUIRE( dblcol.getDataLong( ) == 141 );
  REQUIRE( dblcol.getDataString( ) == s );
    
  cols[1]->setData( d );
  REQUIRE( lngcol.getDataDouble( ) == 3.0 );
  REQUIRE( lngcol.getDataLong( ) == 3 );
  REQUIRE( lngcol.getDataString( ) == "3" );
  cols[1]->setData( l );
  REQUIRE( lngcol.getDataDouble( ) == 9876.0 );
  REQUIRE( lngcol.getDataLong( ) == l );
  REQUIRE( lngcol.getDataString( ) == "9876" );
  cols[1]->setData( s );
  REQUIRE( lngcol.getDataDouble( ) == 141.0 );
  REQUIRE( lngcol.getDataLong( ) == 141 );
  REQUIRE( lngcol.getDataString( ) == "141" );
    
  cols[2]->setData( d );
  REQUIRE( strcol.getDataDouble( ) == d );
  REQUIRE( strcol.getDataLong( ) == 3 );
  REQUIRE( strcol.getDataString( ) == "3.141" );
  cols[2]->setData( l );
  REQUIRE( strcol.getDataDouble( ) == 9876.0 );
  REQUIRE( strcol.getDataLong( ) == l );
  REQUIRE( strcol.getDataString( ) == "9876" );
  cols[2]->setData( s );
  REQUIRE( strcol.getDataDouble( ) == 141.3 );
  REQUIRE( strcol.getDataLong( ) == 141 );
  REQUIRE( strcol.getDataString( ) == s );
}
